/**************************************************************************
 *                     PBS Module(submit + run + status)
 **************************************************************************/

package WebFlow.test;

import WebFlow.*;
import WebFlow.event.*;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.Date;

public class PbsFrame extends Frame implements ActionListener
{
 public PBSImpl4 P4;

 String execdirectory = "/sunhpc/PBS/solaris/bin";

  String directory = "/home/T11F/webflow/WEBFLOW3/QS/kskim/";
  //String directory = "/home/T10F/kskim/PBS/";
  //String tmpdirectory = "/home/T10F/kskim/tmp/";
  String tmpdirectory = "/home/T11F/webflow/WEBFLOW3/QS/kskim/tmp/";

 String command1 = "qsub -m e -q test ";
 String command2 = "qrun ";
 String command3 = "qstat -i ";

 String executable = "TEST";
 String jobid = "jobId";
 
 String disp = "tennessee.npac.syr.edu";
  //String disp = "mirphak.npac.syr.edu";

  /* 
 String scriptfile1 = "/home/T10F/kskim/PBS/subscript";
 String scriptfile2 = "/home/T10F/kskim/PBS/runscript";
 String scriptfile3 = "/home/T10F/kskim/PBS/statusscript";
 */
  
 String scriptfile1 = "/home/T11F/webflow/WEBFLOW3/QS/kskim/subscript";
 String scriptfile2 = "/home/T11F/webflow/WEBFLOW3/QS/kskim/runscript";
 String scriptfile3 = "/home/T11F/webflow/WEBFLOW3/QS/kskim/statusscript";
 
 String editor = "/usr/npac/bin/emacs ";

 String FileName = "status";

 String outputName = "outputPBS"; 
 
 String statusString = null;

 String retString = null;

 int interval = 10;
 int j = 0;
 int id = 0;

 private TextField idField, userNameField, serverField, queueNameField;
 private TextField jobNameField, statusField, outputField;
 private Button submit, clear;

 public PbsFrame(PBSImpl4 P4)
 {
  super("PBS Test ( Job Submit )");

  this.P4 = P4;
   
  setSize(600, 400);
  addWindowListener(new CloseWindow());

  setLayout(new GridLayout(8, 2));

  add(new Label("Job Name : "));
  jobNameField = new TextField("TEST", 20);
  jobNameField.setEditable(false);
  add(jobNameField);

  add(new Label("Job Id : "));
  idField = new TextField(20);
  idField.setEditable(false);
  add(idField);

  add(new Label("User Name : "));
  userNameField = new TextField(20);
  userNameField.setEditable(false);
  add(userNameField);

  add(new Label("Server Name : "));
  serverField = new TextField(20);
  serverField.setEditable(false);
  add(serverField);

  add(new Label("Queue Name : "));
  queueNameField = new TextField(20);
  queueNameField.setEditable(false);
  add(queueNameField);
  /*
  add(new Label("Running Time : "));
  runningTimeField = new TextField(20);
  runningTimeField.setEditable(false);
  add(runningTimeField);
  */
  add(new Label("Job Status : "));
  statusField = new TextField(20);
  statusField.setEditable(false);
  add(statusField);

  add(new Label("Job Output : "));
  outputField = new TextField(20);
  outputField.setEditable(false);
  add(outputField);

  submit = new Button("Submit");
  submit.addActionListener(this);
  add(submit);

  clear = new Button("Clear");
  clear.addActionListener(this);
  add(clear);

  setVisible(true);
 }

/**************************************************************************
 *                             Submit job
 **************************************************************************/
 
 public void actionPerformed(ActionEvent e)
 {
 if(e.getSource() == submit) 
 {
  String FileContents = new String("#!/bin/sh -f\n");
  FileContents += "cd "+execdirectory+"\n";  
  FileContents += command1;
  FileContents += directory+executable+" > ";
  FileContents += tmpdirectory+jobid+"\n";
  
  System.out.println("qsub command = "+FileContents);
  
  int subl = FileContents.length();
  byte[] subbuf = new byte[subl];
  FileContents.getBytes(0, subl, subbuf, 0);

  File to_file = new File(scriptfile1);
  if(to_file.exists())
  {
   if(!to_file.canWrite())
    System.err.println("write failed : file "+scriptfile1+" is unwritable");
  }

  FileOutputStream to = null;
  try{
   to = new FileOutputStream(to_file);
   to.write(subbuf, 0, subl);
  }
  catch(IOException exc){;}
  finally{
    if(to != null) try{to.close();} catch(IOException exc) {;}
  }    
  
  String  cmd1 = "/usr/X11R6/bin/xterm -d "+disp+":0 -e "+ scriptfile1; 
 
  try{
   Process p = Runtime.getRuntime().exec("chmod 777 "+scriptfile1);
   p.waitFor();
   Process p1 = Runtime.getRuntime().exec(cmd1);
   p1.waitFor();

  }
  catch (Exception ex) {
   System.err.println("Error: " + ex.toString());
  }

/**************************************************************************
 *                              Get job-id
 **************************************************************************/

  FileInputStream input = null;
  int[] getint = new int[10];
  id = 0;

  try{
   input = new FileInputStream(tmpdirectory+jobid);
   
   for(int i=0; i<10; i++)
   {
    char ch = (char)input.read();
 
    if(ch == '.')
    {
     j = i;
     break;
    }
    getint[i] = (int)ch - 48;
   }

   for(int i=0; i<j; i++)
    id += (getint[i] * Math.pow(10, j-i-1)); 
 
   System.out.println(Integer.toString(id));
  }

  catch(IOException ioe){;}
  finally{
    if(input != null) try{input.close();} catch(IOException ioe) {;}
  }

/**************************************************************************
 *                           Run submitted job
 **************************************************************************/

  char check_status = 'Q';

  String FileContents2 = new String("#!/bin/sh -f\n");
  FileContents2 += "cd "+execdirectory+"\n";  
  FileContents2 += command2;
  FileContents2 += Integer.toString(id)+"\n";
  
  System.out.println("qrun = "+ FileContents2);

  int sl = FileContents2.length();
  byte[] runbuf = new byte[sl];
  FileContents2.getBytes(0, sl, runbuf, 0);
  
  File to_file2 = new File(scriptfile2);
  if(to_file2.exists())
  {
   if(!to_file2.canWrite())
    System.err.println("write failed : file "+scriptfile2+" is unwritable");
  }

  FileOutputStream to2 = null;

  try{
   to2 = new FileOutputStream(to_file2);
   to2.write(runbuf, 0, sl);
  }
  catch(IOException exce){;}
  finally{
    if(to2 != null) try{to2.close();} catch(IOException exce) {;}
  }    
  
  String  cmd2 = "/usr/X11R6/bin/xterm -d "+disp+":0 -e "+scriptfile2; 
 
  try{
   Process p = Runtime.getRuntime().exec("chmod 777 "+scriptfile2);
   p.waitFor();
   Process p1 = Runtime.getRuntime().exec(cmd2);
   p1.waitFor();
  }
  catch (Exception ex) {
   System.err.println("Error: " + ex.toString());
  }

//-------------------- check status by time interval ----------------------

  while(check_status != 'E')
  {
   if((new Date()).getSeconds() % interval == 0)
   {
    System.out.println("minute : "+(new Date()).getMinutes());
    System.out.println("second : "+(new Date()).getSeconds());
    check_status = displayStatus();
   }
  }

  System.out.println("Exiting time(minute) : "+(new Date()).getMinutes());
  System.out.println("Exiting time(second) : "+(new Date()).getSeconds());

/**************************************************************************
 *                           Display output
 **************************************************************************/
 
  long len = 0;

  FileInputStream input2 = null;

  try{
   File readfile = new File(tmpdirectory+outputName);

   while(!readfile.exists())
   {
    ;
   }
   
   if(!readfile.canRead())
      System.err.println("read failed : file "+readfile+" is unreadable");
    
   if(readfile.exists())
    System.out.println("\nfile exist ? Yes");

   while(len == 0)
   {
    len = readfile.length();
   }

   System.out.println("Writing time(minute) : "+(new Date()).getMinutes());
   System.out.println("Writing time(second) : "+(new Date()).getSeconds());

   char demo[] = new char[(int)len];
   System.out.println("length : "+Integer.toString((int)len));

   input2 = new FileInputStream(tmpdirectory+outputName);

   for(int i=0; i<len; i++)
    demo[i] = (char)input2.read();
   
   retString = new String(demo,0,(int)len);
  }
  catch(IOException ioe){;}
  finally{
    if(input2 != null) try{input2.close();} catch(IOException ioe) {;}
  }

  System.out.println("output content : "+retString);

  outputField.setText(retString);  
 }// if(e.getSource() == submit) 

 else
 {
  jobNameField.setText("");
  idField.setText("");
  userNameField.setText("");
  serverField.setText("");
  queueNameField.setText("");
  //  runningTimeField.setText("");
  statusField.setText("");
  outputField.setText("");  
 }

 } //  public void actionPerformed(ActionEvent e)

/**************************************************************************
 *                           Display status
 **************************************************************************/
 
 public char displayStatus()
 {
  long statuslen = 0;

  String FileContents3 = new String("#!/bin/sh -f\n");
  FileContents3 += "cd "+execdirectory+"\n";
  FileContents3 += command3+Integer.toString(id)+" > ";
  FileContents3 += tmpdirectory+FileName+"\n";

  int statusl = FileContents3.length();
  byte[] statusbuf = new byte[statusl];
  FileContents3.getBytes(0, statusl, statusbuf, 0);

  File to_file3 = new File(scriptfile3);
  if(to_file3.exists())
  {
   if(!to_file3.canWrite())
    System.err.println("write failed : file "+scriptfile3+" is unwritable");
  }

  FileOutputStream to3 = null;
  try{
   to3 = new FileOutputStream(to_file3);
   to3.write(statusbuf, 0, statusl);
  }
  catch(IOException e){;}
  finally{
    if(to3 != null) try{to3.close();} catch(IOException e) {;}
  }    
  
  String cmd3   = "/usr/X11R6/bin/xterm -d "+disp+":0 -e "+ scriptfile3; 

  try{
   Process p1  = Runtime.getRuntime().exec("chmod 777 "+scriptfile3);
   p1.waitFor();
   Process p2 = Runtime.getRuntime().exec(cmd3);
   p2.waitFor();
  }
  catch (Exception ex) {
   System.err.println("Error: " + ex.toString());
  }

//------------- check whether job status is 'Q', 'R', or 'E' --------------

  FileInputStream input3 = null;

  try{
   File statusfile = new File(tmpdirectory+FileName);

   statuslen = statusfile.length();
   char tmp[] = new char[(int)statuslen];
   System.out.println("length : "+Integer.toString((int)statuslen));

   if(statusfile.exists())
   {
    if(!statusfile.canRead())
     System.err.println("read failed : file "+statusfile+" is unreadable");
   }
 
   input3 = new FileInputStream(tmpdirectory+FileName);
 
   for(int i=0; i<statuslen; i++)
    tmp[i] = (char)input3.read();

   statusString = new String(tmp, 0, (int)statuslen);
  }
  catch(IOException ioe){;}
  finally{
    if(input3 != null) try{input3.close();} catch(IOException ioe) {;}
  }

  System.out.println("qstat test => "+statusString);

  char statusChar = statusString.charAt((int)statuslen-8);
  System.out.println("job status test => "+statusChar);

  String jobName = statusString.substring((int)statuslen-47, (int)statuslen-37);
  String userName = statusString.substring((int)statuslen-65, (int)statuslen-57);
  String queueName = statusString.substring((int)statuslen-56, (int)statuslen-49);
  String serverName = statusString.substring(0, statusString.indexOf((int) ':'));

  jobNameField.setText(jobName);
  idField.setText(Integer.toString(id));
  userNameField.setText(userName);
  queueNameField.setText(queueName);
  serverField.setText(serverName);

  switch(statusChar)
  {
   case 'Q' : statusField.setText("Job is queued!");
              System.out.println("Job is queued!");
              break;
   
   case 'R' : statusField.setText("Job is running!");
              System.out.println("Job is running!");
              break;

   case 'E' : statusField.setText("Job is exiting!");
              System.out.println("Job is exiting!");
              break;

   case 'H' : statusField.setText("Job is held!");
              System.out.println("Job is held!");
              break;

   case 'T' : statusField.setText("Job is being moved to new location!");
              System.out.println("Job is being moved to new location!");
              break;

   case 'W' : statusField.setText("Job is waiting for its execution time!");
              System.out.println("Job is waiting for its execution time!");
              break;

   case 'S' : statusField.setText("Job is suspended!");
              System.out.println("Job is suspended!");
              break;
  
   default  : break;
  }
  return statusChar;
 }
}

/**************************************************************************
 *                          class CloseWindow       
 **************************************************************************/

class CloseWindow extends WindowAdapter
{
 public void windowClosing(WindowEvent e)
 {
  e.getWindow().setVisible(false);
  System.exit(0);
 }
}
 
/**************************************************************************
 *                               The End
 **************************************************************************/





